#
# See the file "LICENSE" for the full license governing this code.
#
#
# Check all requirements for facts
#
$LOAD_PATH.unshift "#{Puppet.settings[:environmentpath]}/#{Puppet.settings[:environment]}/modules/ora_config/lib"
begin
  require 'puppet_x/enterprisemodules/oracle/fact'
  require 'puppet/feature/oracle_running'
rescue
  Puppet.warn_once(:no_ora_config, 'OraCis:Facts', 'ora_config not installed; ora_secured facts depend upon ora_config module beeing installed; Skipping ora_secured facts')
  return
end


def ora_secured_fact(fact_name)
  include PuppetX::Oracle::Fact
  include OracleFeature
  if Puppet.features.oracle_running?
    begin
      require 'entitlement/entitlement'
      ::Entitlement::Entitlement.entitled?("ora_secured#facts##{fact_name}")
      Facter.add("ora_#{fact_name}") do
        ora_array_fact(name: 'NAME', sid: 'SID') do
          yield
        end
      end
    rescue
      Puppet.warn_once(:no_ora_secured_entitlements, 'OraCis:Facts', 'ora_secured not entitled on this node; Skipping ora_secured facts')
      Facter.add("ora_#{fact_name}") do
        setcode { [] } # return an empty value
      end
    end
  else
    Facter.add("ora_#{fact_name}") do
      setcode { [] } # return an empty value
    end
  end
end
