task :generate do
  rules = Dir.glob('./manifests/rules/*.pp')
  rules.each do |rule|
    base_name = File.basename(rule).split('.').first
    rule_name = base_name.gsub('_','.').gsub(/r./,'Rule_')
    File.open("./documentation/source/#{rule_name}.md", 'w') do |output_file|
      puts "Generating documentation for #{rule_name}..."
      output_file.write "\n"
      output_file.write "defined type `ora_secured::rules::#{base_name}`"
      output_file.write "\n"
      File.open(rule, 'r') do |input_file|
        parameters = []
        parameter_block = false
        input_file.each_line do |line|
          if line =~ /# Parameters\:/
            parameter_block = true
            next
          end
          if parameter_block && line =~ /#\s*\$(.*)\s*\:/
            parameters << ":#{$~[1]},"
            next
          end
          output_file.write line[1, line.length - 1] if line[0] == '#' && ! parameter_block
        end
        output_file.write "\n"
        output_file.write "Here is an example on how to enable this rule:\n"
        output_file.write "\n"
        output_file.write "``` puppet\n"
        output_file.write "ora_secured::rules::#{base_name} { 'DBSID':}\n"
        output_file.write "```\n"
        output_file.write "\n"
        output_file.write "<%- include_attributes [\n#{parameters.join("\n")}\n]%>\n"
      end
    end
  end
end
