#
# See the file "LICENSE" for the full license governing this code.
#
#
# Set the init.ora param to the specfied value
#
# $title      init,.ora parameter including the sid e.g. AUDIT_SYS_OPERATIONS@SID
# $value      Value to set the paremeter ro
# $ensure     Absent or present. Default 'present'
#
define ora_secured::internal::parameter(
  Any                       $value,
  Enum['present', 'absent'] $ensure = 'present'
){
  $split        = $title.split('@')
  $parameter    = $split[0]
  $sid          = $split[1]
  $tag          = $split[2]

  if ! $tag {
    $unique = ora_secured::random_id(6)
  } else {
    $unique = $tag
  }

  $full_name_ensure = "Ora_init_param[SPFILE/${parameter}@${sid}]ensure/${unique}"
  resource_value { $full_name_ensure:
    value          => $ensure,
    allow_create   => true,
    allow_redefine => true,
    warnings       => false
  }
  $full_name_value = "Ora_init_param[SPFILE/${parameter}@${sid}]value/${unique}"
  resource_value { $full_name_value:
    value          => $value,
    allow_create   => true,
    allow_redefine => true,
    warnings       => false
  }

}
